package edu.mermet.tp8.fenetres;

import edu.mermet.tp8.Application;
import edu.mermet.tp8.XmlUtilisateur;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.util.*;
import java.util.List;


public class FenetreSuggestion extends JDialog {

    private ResourceBundle
            bundleAstuces = ResourceBundle.getBundle("Astuces/astuces", Locale.FRENCH);

    private XmlUtilisateur xmlUtilisateur;

    private String libelleAstuce;
    private String astuceAffichee;



    private JLabel lblMessage;

    private JPanel conteneurBtn;
    private JButton fermer;
    private JButton nePlusAfficher;

    private boolean aAfficher;

    private Application owner;


    public FenetreSuggestion(Application parent, XmlUtilisateur u){
        super(parent,"Suggestion du jour", true);
        this.xmlUtilisateur = u;
        this.owner = parent;


        this.ajouterClesAstucesUserXML();
        this.tirerAstuceEnCours();


        this.lblMessage = new JLabel(this.astuceAffichee);
        this.add(lblMessage, BorderLayout.NORTH);

        this.conteneurBtn = new JPanel();

        this.fermer=new JButton(new ActionFermer());
        this.fermer.setText("Fermer");
        this.conteneurBtn.add(fermer);

        this.nePlusAfficher = new JButton(new ActionNePlusAfficher());
        this.nePlusAfficher.setText("Ne plus afficher");
        this.conteneurBtn.add(nePlusAfficher);

        this.add(conteneurBtn, BorderLayout.SOUTH);


        this.pack();
        this.setLocationRelativeTo(null);
        this.setVisible(this.aAfficher);
    }


    public void ajouterClesAstucesUserXML(){
        Enumeration<String> cles = bundleAstuces.getKeys();

        while(cles.hasMoreElements()){
            String cle = cles.nextElement();
            if(xmlUtilisateur.getProperty(cle).equals("")){
                xmlUtilisateur.setProperty(cle, "true");
            }
        }

        xmlUtilisateur.enregistrer();

    }


    public void tirerAstuceEnCours(){

        List<String> listeLib = new ArrayList<>();
        listeLib.addAll(bundleAstuces.keySet());
        Collections.shuffle(listeLib);

        for(String astuce : listeLib){
            if(xmlUtilisateur.getProperty(astuce).equals("true")){
                this.libelleAstuce = astuce;
                break;
            }else{
                this.libelleAstuce = null;
            }
        }

        if(this.libelleAstuce == null) this.libelleAstuce = "";

        if(this.libelleAstuce.equals("")){
            this.astuceAffichee = "Aucune astuce";
            this.aAfficher = false;
        }
        else{
            this.astuceAffichee = this.getAstuceDepuisLibelle();
            this.aAfficher = true;
        }

    }


    public String getAstuceDepuisLibelle(){
            return bundleAstuces.getString(this.libelleAstuce);
    }


    private class ActionFermer extends AbstractAction{
        public ActionFermer(){
            super("Fermer");
        }
        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            setVisible(false);
        }
    }

    private class ActionNePlusAfficher extends AbstractAction{
        public ActionNePlusAfficher(){
            super("Ne plus afficher");
        }
        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            setVisible(false);
            xmlUtilisateur.setProperty(libelleAstuce, "false");
            xmlUtilisateur.enregistrer();
        }
    }

}
